#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXNUM = 1000000 + 10;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
int cnt;
llong ans;
int a[MAXN];
bool colored[MAXNUM];
int begin[MAXNUM];
int end[MAXNUM];

void solve()
{
    std::fill(begin + 1, begin + MAXNUM, INF);
    for (int i = 1 ; i <= n ; ++i)
    {
        cnt += (begin[a[i]] == INF);
        begin[a[i]] = std::min(begin[a[i]], i);
        end[a[i]] = std::max(end[a[i]], i);
    }

    for (int i = 1 ; i < MAXNUM ; ++i)
    {
        if (begin[i] == INF) continue;
        ans += end[i] - begin[i] + 1;
    }
}

void output()
{
    int cntMoves = 0;
    std::cout << cnt << ' ' << ans << '\n';
    for (int i = 1 ; i <= n ; ++i)
    {
        if (colored[a[i]] || a[i] == 0)
        {
            continue;
        }

        std::cout << "Move " << ++cntMoves << ": " << a[i] << ' ' << i << ' ' << end[a[i]] << '\n';
        colored[a[i]] = true;
    }
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();
    output();

    return 0;
}