#include <bits/stdc++.h>
using namespace std;

string readLine() {
    string s;
    assert(getline(cin, s));
    return s;
}

void assertEOF() {
    string s;
    assert(!getline(cin, s));
}

vector<string> readTokens(char delim) {
    string s = readLine();
    if (s.empty()) return {};

    vector<string> tokens(1);
    for (char c: s) {
        if (c == delim) tokens.push_back("");
        else tokens.back().push_back(c);
    }
    return tokens;
}

vector<int> intTokens(char delim) {
    vector<string> a = readTokens(delim);
    vector<int> b;
    for (string& s: a) {
        b.push_back(stoi(s));
    }
    return b;
}

int a[100001];
int zeros[100001];
int l[1000001];
int r[1000001];

int main() {
    vector<int> line1 = intTokens(' ');
    vector<int> line2 = intTokens(' ');
    assertEOF();

    assert(line1.size() == 1);
    int n = line1[0];

    assert(line2.size() == n);
    int nonZeros = 0;
    for (int x: line2) {
        assert(0 <= x && x <= n);
        if (x != 0) nonZeros++;
    }
    assert(nonZeros > 0);

    for (int i = 1; i <= n; i++) a[i] = line2[i-1];
    for (int i = 1; i <= n; i++) zeros[i] = zeros[i-1]+(a[i]==0);

    for (int i = 1; i <= n; i++) r[a[i]] = i;
    for (int i = n; i >= 1; i--) l[a[i]] = i;
    vector<pair<int, int>> v;
    for (int i = 1; i <= n; i++) {
        if (l[i] != 0) {
            v.push_back({l[i], r[i]});
            assert(zeros[r[i]]-zeros[l[i]-1] == 0);
        }
    }
    sort(v.begin(), v.end());
    stack<pair<int, int>> st;
    for (int i = 0; i < v.size(); i++) {
        while (st.size() && st.top().second < v[i].first) st.pop();
        if (st.size()) assert(st.top().first < v[i].first && st.top().second > v[i].second);

        st.push(v[i]);
    }

    cout << n << " " << nonZeros << endl;

    return 0;
}

