#include <bits/stdc++.h>

using namespace std;

int a[100001];
int l[1000001];
int r[1000001];
int before[1000001];
int used[1000001];

vector<string> getTokens(string& s, char delim) {
    if (s.empty()) return {};

    vector<string> tokens(1);
    for (char c: s) {
        if (c == delim) tokens.push_back("");
        else tokens.back().push_back(c);
    }
    return tokens;
}

bool isInt(string& s) {
    if (s.size() == 0) return false;
    if (s.size() >= 10) return false;
    for (char c: s) {
        if (!isdigit(c)) return false;
    }
    return true;
}

int toInt(string& s) {
    int ans = 0;
    for (char c: s) {
        ans = 10*ans+c-'0';
    }
    return ans;
}

void finish(bool ok1, bool ok2, bool ok3, string message) {
    int parts = 0;
    if (ok1) parts++;
    if (ok2) parts+=2;
    if (ok3) parts++;
    if (parts == 0) cout << 0 << endl;
    else if (parts == 1) cout << 0.25 << endl;
    else if (parts == 2) cout << 0.5 << endl;
    else if (parts == 3) cout << 0.75 << endl;
    else cout << 1 << endl;

    if (message.size()) cerr << message << endl;
    exit(0);
}

int main(int argc, char *argv[])
{
    ifstream in(argv[1]);
    ifstream out(argv[3]);

    if (!in) {
        finish(0, 0, 0, "In-файл "+string(argv[1])+" не е намерен.");
    }
    if (!out) {
        finish(0, 0, 0, "Out-файл "+string(argv[3])+" не е намерен.");
    }

    int n; in >> n;
    for (int i = 1; i <= n; i++) in >> a[i];
    for (int i = 1; i <= n; i++) r[a[i]] = i;
    for (int i = n; i >= 1; i--) l[a[i]] = i;

    int solBr, solLen;
    stack<int> st;
    for (int i = 1; i <= n; i++) {
        if (a[i] == 0 || l[a[i]] != i) continue;

        solBr++;
        solLen+=r[a[i]]-l[a[i]]+1;
        while (st.size() && r[st.top()] < i) st.pop();
        if (st.size()) before[a[i]]=st.top();
        st.push(a[i]);
    }

    int br, len;
    if (!(out >> br >> len)) {
        finish(0, 0, 0, "Липсва броя цветове и/или количеството боя");
    }

    string message;
    bool ok1 = (br == solBr);
    if (ok1) message += "Верен брой цветове\n";
    else message += "Грешен брой цветове\n";

    bool ok2 = (len == solLen);
    if (ok2) message += "Вярно количество боя\n";
    else message += "Грешно количество боя\n";

    vector<string> moves;
    string s;

    while (getline(out, s) && moves.size() <= solBr) {
        if (s.size() > 4 && toupper(s[0]) == 'M' &&
            toupper(s[1]) == 'O' && toupper(s[2]) == 'V' && toupper(s[3]) == 'E') {
            moves.push_back(s);
        }
    }

    if (moves.size() == 0) {
        message += "Липсват ходове";
        finish(ok1, ok2, false, message);
    }

    if (moves.size() < solBr) {
        message += "Ходовете са по-малко от очакваното";
        finish(ok1, ok2, false, message);
    }

    if (moves.size() > solBr) {
        message += "Ходовете са повече от очакваното";
        finish(ok1, ok2, false, message);
    }

    for (int i = 0; i < moves.size(); i++) {
        auto pos = moves[i].find(":");
        if (pos == string::npos) {
            message += "В някой ход липсва символа \":\"";
            finish(ok1, ok2, false, message);
        }
        string part1 = moves[i].substr(4, pos-4);
        string part2 = moves[i].substr(pos+1);

        while (part1[0] == ' ') part1.erase(0, 1);
        while (part1.back() == ' ') part1.pop_back();

        if (!isInt(part1)) {
            message += "В някой ход частта преди символа \":\" не е валидна";
            message += part1;
            finish(ok1, ok2, false, message);
        }
        if (toInt(part1) != i+1) {
            message += "В някой ход номера на хода не е верен";
            finish(ok1, ok2, false, message);
        }

        while (part2[0] == ' ') part2.erase(0, 1);
        while (part2.back() == ' ') part2.pop_back();

        int badCharacters = 0;
        for (char c: part2) {
            if (c != ' ' && !isdigit(c)) badCharacters++;
        }
        if (badCharacters > 0) {
            message += "В някой ход часста след символа \":\" има символ различен от интервал и цифра";
            finish(ok1, ok2, false, message);
        }
        vector<string> tokens = getTokens(part2, ' ');
        if (tokens.size() < 3) {
            message += "В някой ход часста след символа \":\" има по-малко от 3 числа";
            finish(ok1, ok2, false, message);
        }
        if (tokens.size() > 3) {
            message += "В някой ход часста след символа \":\" има повече от 3 числа";
            finish(ok1, ok2, false, message);
        }
        if (!isInt(tokens[0])) {
            message += "В някой ход е даден невалиден номер на цвят";
            finish(ok1, ok2, false, message);
        }
        if (!isInt(tokens[1]) || !isInt(tokens[2])) {
            message += "В някой ход е даден невалиден край на интервал";
            finish(ok1, ok2, false, message);
        }
        int c = toInt(tokens[0]);
        int x = toInt(tokens[1]);
        int y = toInt(tokens[2]);
        if (c <= 0 || c > 1000000) {
            message += "В някой ход е даден невалиден номер на цвят";
            finish(ok1, ok2, false, message);
        }
        if (x < 1 || x > n || y < 1 || y > n) {
            message += "В някой ход е даден невалиден край на интервал";
            finish(ok1, ok2, false, message);
        }
        if (x > y) {
            message += "В някой ход левия край на интервала е по-голям от десния";
            finish(ok1, ok2, false, message);
        }
        if (l[c] == 0) {
            message += "В някой ход е даден цвят, който не е използван";
            finish(ok1, ok2, false, message);
        }
        if (used[c]) {
            message += "В списъка от ходове има повтарящ се цвят";
            finish(ok1, ok2, false, message);
        }
        if (x != l[c] || y != r[c]) {
            message += "В някой ход интервала за съответния цвят е грешен";
            finish(ok1, ok2, false, message);
        }
        if (before[c] && !used[before[c]]) {
            message += "Грешен списък от ходове";
            finish(ok1, ok2, false, message);
        }
        used[c] = true;
    }
    message += "Верен списък от ходове";
    finish(ok1, ok2, true, message);

    return 0;
}
